/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.jtests.clients.entity;

import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import junit.framework.Test;
import junit.framework.TestSuite;
import org.objectweb.jonas.jtests.beans.fbasic.SimpleHome;
import org.objectweb.jonas.jtests.beans.fbasic.Simple;
import org.objectweb.jonas.jtests.util.JTestCase;
import java.util.Enumeration;

/**
 * This set of test are basic tests on CMP version 2 entity home interface.
 * All tests common to CMP are in the inherited class A_BasicHomeInterfaceEC.
 * @author Helene Joanin (JOnAS team)
 */
public class G_BasicHomeInterfaceEC2 extends B_BasicHomeInterfaceEC {

    private static String BEAN_HOME = "fbasicSimpleEC2Home";

    public G_BasicHomeInterfaceEC2(String name) {
        super(name);
    }
     
    public void testEmpty() throws Exception {
        getHome();
    }

    public SimpleHome getHome() {
        if (home == null) {
            try {
                home = (SimpleHome) PortableRemoteObject.narrow(ictx.lookup(BEAN_HOME), SimpleHome.class);
            } catch (NamingException e) {
                fail("Cannot get bean home");
            }
            // init here tables if CMP2
            try {
                home.findByPrimaryKey("pk1");
            } catch (Exception e) {
                // pk1 not found: we can create 
                try {
                    home.create("pk1", 10, 4);
                    home.create("pk2", 10, 4);
                    home.create("pk3", 10, 4);
                    home.create("pk4", 40, 8);
                    home.create("pk5", 50, 8);
                    home.create("pk6", 60, 8);
                    home.create("pk7", 70, 8);
                    home.create("pk8", 45, 20);
                    home.create("pk9", 55, 30);
                    home.create("pk10",80, 80);
                    home.create("pk11",80, 80);
                    home.create("pk12",90, 90);
                    home.create("pk13",100, 90);
                    home.create("pk14",110, 90);
                    // to get a big table
                    for (int i = 0; i < 1000; i++) {
                        home.create(Integer.toString(i), 0, 0); 
                    }

                } catch (Exception i) {
                    fail ("cannot create elements of table");
                }
            }
        }
        return home;
    }

    /**
     * This suite is all CMP test cases
     */
    public static Test suite() {
        return new TestSuite(G_BasicHomeInterfaceEC2.class);
    }

    public static void main (String args[]) throws Exception {
   
        String testtorun = null;
        // Get args
        for (int argn = 0; argn < args.length; argn++) {
            String s_arg = args[argn];
            Integer i_arg;
            if (s_arg.equals("-n")) {
                testtorun = args[++argn];
            }
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
	   
            junit.textui.TestRunner.run(new G_BasicHomeInterfaceEC2(testtorun));
	   
        }
    }
}
